/************************************************************************************/
/*  Program name CAPFAIMP_MASSADD_DIST.sql                                  	    */
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 17 JAN, 2006   NIP Karen         First created                                   */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAIMP_MASSADD_DIST';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FA_MASSADD_DIST;
	
	lv_Next_Seq_ID		NUMBER;
	lv_COA_ID			NUMBER;
	lv_Book_Type_Code	VARCHAR2(100);

BEGIN
	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	FA_MASSADD_DISTRIBUTIONS_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;
			
			INSERT INTO CRST_FA_MASSADD_DIST_MAP 
			VALUES
			(
			C1.MASSADD_DIST_ID,   
			lv_Next_Seq_ID
			);
			
			SELECT	BOOK_TYPE_CODE
			INTO	lv_Book_Type_Code
			FROM	FA_MASS_ADDITIONS
			WHERE	MASS_ADDITION_ID	=	C1.MASS_ADDITION_ID;
			
			lv_COA_ID := CAPBRIMP_COMMON.GetCOAIDfromBTC(lv_Book_Type_Code);
			
			INSERT INTO FA_MASSADD_DISTRIBUTIONS
			VALUES
			(
			lv_Next_Seq_ID,
			CAPBRIMP_MAPPING.GetMassAdditionMapping(C1.MASS_ADDITION_ID),
			C1.UNITS,
			CAPBRIMP_COMMON.GetSegment(lv_COA_ID,C1.DEPRN_EXPENSE_CCID_D),
			C1.LOCATION_ID,
			C1.EMPLOYEE_ID,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),
			C1.LAST_UPDATE_LOGIN,
			C1.LAST_UPDATE_DATE
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;
	
	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/